module     p0_dubar_emnebarg_golem95h1
   use precision_golem, only: ki_gol => ki
   use p0_dubar_emnebarg_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p0_dubar_emnebarg_config
   use p0_dubar_emnebarg_groups, only: tensrec_info_group0
   use p0_dubar_emnebarg_d1h1l1, only: numerator_d1 => numerator_golem95
   use p0_dubar_emnebarg_d1h1l1d, only: reconstruct_d1
   use p0_dubar_emnebarg_d2h1l1, only: numerator_d2 => numerator_golem95
   use p0_dubar_emnebarg_d2h1l1d, only: reconstruct_d2
   use p0_dubar_emnebarg_d3h1l1, only: numerator_d3 => numerator_golem95
   use p0_dubar_emnebarg_d3h1l1d, only: reconstruct_d3
   use p0_dubar_emnebarg_d4h1l1, only: numerator_d4 => numerator_golem95
   use p0_dubar_emnebarg_d4h1l1d, only: reconstruct_d4
   use p0_dubar_emnebarg_d7h1l1, only: numerator_d7 => numerator_golem95
   use p0_dubar_emnebarg_d7h1l1d, only: reconstruct_d7
   use p0_dubar_emnebarg_d8h1l1, only: numerator_d8 => numerator_golem95
   use p0_dubar_emnebarg_d8h1l1d, only: reconstruct_d8
   use p0_dubar_emnebarg_d10h1l1, only: numerator_d10 => numerator_golem95
   use p0_dubar_emnebarg_d10h1l1d, only: reconstruct_d10
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 1:
      if (tens_rec_by_derivatives) then
         call reconstruct_d1(coeffs)
      else
         call reconstruct2(numerator_d1, coeffs%coeffs_1)
      end if
   !------#] Diagram 1:
   !------#[ Diagram 2:
      if (tens_rec_by_derivatives) then
         call reconstruct_d2(coeffs)
      else
         call reconstruct2(numerator_d2, coeffs%coeffs_2)
      end if
   !------#] Diagram 2:
   !------#[ Diagram 3:
      if (tens_rec_by_derivatives) then
         call reconstruct_d3(coeffs)
      else
         call reconstruct1(numerator_d3, coeffs%coeffs_3)
      end if
   !------#] Diagram 3:
   !------#[ Diagram 4:
      if (tens_rec_by_derivatives) then
         call reconstruct_d4(coeffs)
      else
         call reconstruct1(numerator_d4, coeffs%coeffs_4)
      end if
   !------#] Diagram 4:
   !------#[ Diagram 7:
      if (tens_rec_by_derivatives) then
         call reconstruct_d7(coeffs)
      else
         call reconstruct3(numerator_d7, coeffs%coeffs_7)
      end if
   !------#] Diagram 7:
   !------#[ Diagram 8:
      if (tens_rec_by_derivatives) then
         call reconstruct_d8(coeffs)
      else
         call reconstruct2(numerator_d8, coeffs%coeffs_8)
      end if
   !------#] Diagram 8:
   !------#[ Diagram 10:
      if (tens_rec_by_derivatives) then
         call reconstruct_d10(coeffs)
      else
         call reconstruct2(numerator_d10, coeffs%coeffs_10)
      end if
   !------#] Diagram 10:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use p0_dubar_emnebarg_config
   use p0_dubar_emnebarg_groups, only: tensrec_info_group1
   use p0_dubar_emnebarg_d6h1l1, only: numerator_d6 => numerator_golem95
   use p0_dubar_emnebarg_d6h1l1d, only: reconstruct_d6
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 6:
      if (tens_rec_by_derivatives) then
         call reconstruct_d6(coeffs)
      else
         call reconstruct3(numerator_d6, coeffs%coeffs_6)
      end if
   !------#] Diagram 6:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use p0_dubar_emnebarg_config
   use p0_dubar_emnebarg_groups, only: tensrec_info_group2
   use p0_dubar_emnebarg_d5h1l1, only: numerator_d5 => numerator_golem95
   use p0_dubar_emnebarg_d5h1l1d, only: reconstruct_d5
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 5:
      if (tens_rec_by_derivatives) then
         call reconstruct_d5(coeffs)
      else
         call reconstruct3(numerator_d5, coeffs%coeffs_5)
      end if
   !------#] Diagram 5:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
end module p0_dubar_emnebarg_golem95h1
