module     p3_udbar_neepg_d10h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W1jet/1.4/Virtual/p
   ! 3_udbar_neepg/helicity0/d10h0l1d.f90
   ! generator: haggies (1.1)
   use p3_udbar_neepg_config, only: ki
   use p3_udbar_neepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d10
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_udbar_neepg_globalsl1, only: epspow
      use p3_udbar_neepg_kinematics
      use p3_udbar_neepg_abbrevh0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      real(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t6 = dotproduct(k1, qshift)
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb10n12+t1*abb10n16+t6*abb10n18+abb10n14*dotproduct(qshif&
         &t, qshift)+abb10n17*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak&
         &2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb10n19*(spvak1k5(1)*qshift(1&
         &)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-spvak1k5(4)*qshift(4))+a&
         &bb10n21*dotproduct(k5, qshift)+t1*t2*abb10n13+t1*t6*abb10n15)
         return
      end if
      t3 = k1(iv1)
      t4 = spvak2k5(iv1)
      t5 = spvak5k1(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb10n21+qshift(iv1)*abb10n20+spvak1k5(iv1)*abb10n&
         &19+spvak2k1(iv1)*abb10n17+t3*abb10n18+t4*abb10n16+t1*t3*abb10n15+t1*t5&
         &*abb10n13+t2*t4*abb10n13+t4*t6*abb10n15)
         return
      end if
      t1 = spvak2k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb10n14+k1(iv2)*t4*abb10n15+spvak5k1(&
         &iv2)*t4*abb10n13+t1*t3*abb10n15+t1*t5*abb10n13)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d10:
   subroutine     reconstruct_d10(coeffs)
      use p3_udbar_neepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_10:
      coeffs%coeffs_10%c0 = derivative(czip)
      coeffs%coeffs_10%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_10%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_10%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_10%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_10%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_10%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_10%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_10%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_10%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_10%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_10%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_10%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_10%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_10%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_10:
   end subroutine reconstruct_d10
!---#] subroutine reconstruct_d10:
end module p3_udbar_neepg_d10h0l1d
