module     p3_udbar_neepg_d6h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W1jet/1.4/Virtual/p
   ! 3_udbar_neepg/helicity0/d6h0l1.f90
   ! generator: haggies (1.1)
   use p3_udbar_neepg_config, only: ki
   use p3_udbar_neepg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p3_udbar_neepg_groups, only: &
!           & sign => diagram6_sign, shift => diagram6_shift
      use p3_udbar_neepg_globalsl1, only: epspow
      use p3_udbar_neepg_kinematics
      use p3_udbar_neepg_abbrevh0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d6 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      d6 = (t1*abb6n1+t2*abb6n2+t3*abb6n3+t4*abb6n4+t4*t4*abb6n7+t5*abb6n5+t6*ab&
      &b6n8+t1*t4*abb6n9+t2*t4*abb6n6+t2*t7*abb6n11+t3*t7*abb6n14+t4*t5*abb6n15+&
      &t4*t7*abb6n10+t4*abb6n13*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1&
      &(3)-Q(4)*spvak5k1(4))+t6*t7*abb6n12+t1*t4*t7*abb6n16)
      numerator = cmplx(real(d6, ki), aimag(d6), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p3_udbar_neepg_globalsl1, only: epspow
      use p3_udbar_neepg_kinematics
      use p3_udbar_neepg_abbrevh0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d6 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      d6 = (t1*abb6n1+t2*abb6n2+t3*abb6n3+t4*abb6n4+t4*t4*abb6n7+t5*abb6n5+t6*ab&
      &b6n8+t1*t4*abb6n9+t2*t4*abb6n6+t2*t7*abb6n11+t3*t7*abb6n14+t4*t5*abb6n15+&
      &t4*t7*abb6n10+t4*abb6n13*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1&
      &(3)-Q(4)*spvak5k1(4))+t6*t7*abb6n12+t1*t4*t7*abb6n16)

      numerator = cmplx(real(d6, ki), aimag(d6), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p3_udbar_neepg_d6h0l1
